unit AVLZH;
interface
 uses Dos, objects, arcView;
 Type      TLFHeader=Record
                     Headsize,Headchk          :byte;
                     HeadID                    :packed Array[1..5] of char;
                     Packsize,Origsize,Filetime:longint;
                     Attr                      :word;
                     Filename                  :string[12];
                     f32                       :pathstr;
                   end;

     PLZHArchive=^TLZHArchive;
     TLZHArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  private
                   Header:TLFHeader;
                   Dir:PathStr;
                   Procedure GetHeader;
                 end;
Function CheckLZHHeader(var Buff):Boolean;
{also used in OpenArchive function}
implementation
 Constructor TLZHArchive.Init;
 begin
  Inherited Init(AFile);
  GetHeader;
  if Header.HeadSize=0 then
   begin
    Dispose(F,Done);
    Fail;
   end;
 end;
 Function TLZHArchive.FindNext(var Sr:TArcRec):boolean;
 var i:Integer;LongNamePtr:PString;LongName:String;
 begin
  if Header.HeadSize=0 then FindNext:=False
   else
   With Header do
    begin
     if (HeadId[4]='5')and(Header.Attr and $100<>0) then
     begin
      LongNamePtr:=PString(Longint(@Header)+Header.HeadSize);
      if Length(LongNamePtr^)>3 then
      Dir:=Copy(LongNamePtr^,3,Length(LongNamePtr^)-3)
      else Dir:='';
      For i:=1 to length(Dir) do
       if Dir[i]=#255 then Dir[i]:='\';
      Sr.Name:=Dir+Header.FileName;
     end
     else Sr.Name:=Header.FileName;
     Sr.Attr:=Header.Attr and $3F;
     Sr.Size:=Header.OrigSize;
     Sr.PackedSize:=Header.PackSize;
     Sr.Time:=Header.FileTime;
     GetHeader;
     FindNext:=True;
   end;
 end;
 Procedure TLZHArchive.GetHeader;
 var OldPos:LongInt;
 begin
  Header.HeadSize:=0;
  OldPos:=F^.GetPos;
  F^.Read(Header,SizeOf(header));
  if (F^.Status<>0)or not CheckLZHHeader(Header) then exit;
  With Header do
   if HeadSize<>0 then
   F^.Seek(OldPOs+2+HeadSize+PackSize);
 end;
Function CheckLZHHeader(var Buff):Boolean;
var H:TLFHeader absolute buff;
begin
 With H do
  begin
   CheckLZHHeader:=(HeadID[1]='-')and(HeadID[5]='-')and(HeadID[2]='l')
    and (HeadID[3]='h');
  end;
end;
end.
